Index: protocols/nogaim.h
===================================================================
--- protocols/nogaim.h	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ protocols/nogaim.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,11 +1,10 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2012 Wilmer van der Gaast and others                *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
   \********************************************************************/
 
 /*
- * nogaim, soon to be known as im_api. Not a separate product (unless
- * someone would be interested in such a thing), just a new name.
+ * nogaim
  *
  * Gaim without gaim - for BitlBee
@@ -16,5 +15,5 @@
  * Copyright (C) 1998-1999, Mark Spencer <markster@marko.net>
  *                          (and possibly other members of the Gaim team)
- * Copyright 2002-2012 Wilmer van der Gaast <wilmer@gaast.net>
+ * Copyright 2002-2004 Wilmer van der Gaast <lintux@lintux.cx>
  */
 
@@ -32,6 +31,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -39,49 +38,45 @@
 #define _NOGAIM_H
 
-#if (__sun)
-#include <inttypes.h>
-#else
-#include <stdint.h>
-#endif
-
 #include "bitlbee.h"
-#include "account.h"
 #include "proxy.h"
-#include "query.h"
 #include "md5.h"
-#include "ft.h"
-
+#include "sha.h"
+
+
+#define BUF_LEN MSG_LEN
+#define BUF_LONG ( BUF_LEN * 2 )
+#define MSG_LEN 2048
+#define BUF_LEN MSG_LEN
+
+#define SELF_ALIAS_LEN 400
 #define BUDDY_ALIAS_MAXLEN 388   /* because MSN names can be 387 characters */
 
-#define WEBSITE "https://www.bitlbee.org/"
-
-/* Sharing flags between all kinds of things. I just hope I won't hit any
-   limits before 32-bit machines become extinct. ;-) */
-#define OPT_LOGGED_IN   0x00000001
-#define OPT_LOGGING_OUT 0x00000002
-#define OPT_AWAY        0x00000004
-#define OPT_MOBILE      0x00000008
-#define OPT_DOES_HTML   0x00000010
-#define OPT_LOCALBUDDY  0x00000020 /* For nicks local to one groupchat */
-#define OPT_SLOW_LOGIN  0x00000040 /* I.e. Twitter Oauth @ login time */
-#define OPT_TYPING      0x00000100 /* Some pieces of code make assumptions */
-#define OPT_THINKING    0x00000200 /* about these values... Stupid me! */
-#define OPT_NOOTR       0x00001000 /* protocol not suitable for OTR */
-#define OPT_PONGS       0x00010000 /* Service sends us keep-alives */
-#define OPT_PONGED      0x00020000 /* Received a keep-alive during last interval */
-#define OPT_SELFMESSAGE 0x00080000 /* A message sent by self from another location */
+#define PERMIT_ALL      1
+#define PERMIT_NONE     2
+#define PERMIT_SOME     3
+#define DENY_SOME       4
+
+#define WEBSITE "http://www.bitlee.org/"
+#define IM_FLAG_AWAY 0x0020
+#define OPT_CONN_HTML 0x00000001
+#define OPT_LOGGED_IN 0x00010000
+#define GAIM_AWAY_CUSTOM "Custom"
+
+#define GAIM_LOGO	0
+#define GAIM_ERROR	1
+#define GAIM_WARNING	2
+#define GAIM_INFO	3
 
 /* ok. now the fun begins. first we create a connection structure */
-struct im_connection {
-	account_t *acc;
-	uint32_t flags;
-
-	/* each connection then can have its own protocol-specific data */
-	void *proto_data;
-
+struct gaim_connection {
+	/* we need to do either oscar or TOC */
+	/* we make this as an int in case if we want to add more protocols later */
+	int protocol;
+	struct prpl *prpl;
+	guint32 flags;
+	
 	/* all connections need an input watcher */
 	int inpa;
-	guint keepalive;
-
+	
 	/* buddy list stuff. there is still a global groups for the buddy list, but
 	 * we need to maintain our own set of buddies, and our own permit/deny lists */
@@ -89,37 +84,51 @@
 	GSList *deny;
 	int permdeny;
-
+	
+	/* all connections need a list of chats, even if they don't have chat */
+	GSList *buddy_chats;
+	
+	/* each connection then can have its own protocol-specific data */
+	void *proto_data;
+	
+	struct aim_user *user;
+	
+	char username[64];
+	char displayname[128];
+	char password[32];
+	guint keepalive;
+	/* stuff needed for per-connection idle times */
+	guint idle_timer;
+	time_t login_time;
+	time_t lastsent;
+	int is_idle;
+	
 	char *away;
-
+	int is_auto_away;
+	
+	int evil;
+	gboolean wants_to_die; /* defaults to FALSE */
+	
 	/* BitlBee */
-	bee_t *bee;
-
-	GSList *groupchats;
-	GSList *chatlist;
-	GHashTable *bee_users;
-};
-
-struct groupchat {
-	struct im_connection *ic;
+	irc_t *irc;
+	int lstitems;  /* added for msnP8 */
+	
+	struct conversation *conversations;
+};
+
+/* struct buddy_chat went away and got merged with this. */
+struct conversation {
+	struct gaim_connection *gc;
 
 	/* stuff used just for chat */
-	/* The in_room variable is a list of handles (not nicks!), kind of
-	 * "nick list". This is how you can check who is in the group chat
-	 * already, for example to avoid adding somebody two times. */
-	GList *in_room;
-	//GList *ignored;
-
-	//struct groupchat *next;
-	/* The title variable contains the ID you gave when you created the
-	 * chat using imcb_chat_new(). */
-	char *title;
-	/* Use imcb_chat_topic() to change this variable otherwise the user
-	 * won't notice the topic change. */
-	char *topic;
-	char joined;
-	/* This is for you, you can add your own structure here to extend this
-	 * structure for your protocol's needs. */
-	void *data;
-	void *ui_data;
+        GList *in_room;
+        GList *ignored;
+        int id;
+        
+        /* BitlBee */
+        struct conversation *next;
+        char *channel;
+        char *title;
+        char joined;
+        void *data;
 };
 
@@ -127,269 +136,212 @@
 	char name[80];
 	char show[BUDDY_ALIAS_MAXLEN];
-	int present;
+        int present;
+	int evil;
 	time_t signon;
 	time_t idle;
-	int uc;
+        int uc;
 	guint caps; /* woohoo! */
 	void *proto_data; /* what a hack */
-	struct im_connection *ic; /* the connection it belongs to */
-};
-
-struct buddy_action {
-	char *name;
-	char *description;
-};
-
-/* This enum takes a few things from libpurple and a few things from old OPT_ flags.
- * The only flag that was used before this struct was PRPL_OPT_NOOTR.
- *
- * The libpurple ones only use the same values as the PurpleProtocolOptions
- * enum for convenience, but there's no promise of direct compatibility with
- * those values. As of libpurple 2.8.0 they use up to 0x800 (1 << 11), which is
- * a nice coincidence.
- */
-typedef enum {
-	/* The protocol doesn't use passwords
-	 * Mirrors libpurple's OPT_PROTO_NO_PASSWORD */
-	PRPL_OPT_NO_PASSWORD = 1 << 4,
-
-	/* The protocol doesn't require passwords, but may use them
-	 * Mirrors libpurple's OPT_PROTO_PASSWORD_OPTIONAL */
-	PRPL_OPT_PASSWORD_OPTIONAL = 1 << 7,
-
-	/* The protocol is not suitable for OTR, see OPT_NOOTR */
-	PRPL_OPT_NOOTR = 1 << 12,
-} prpl_options_t;
+	struct gaim_connection *gc; /* the connection it belongs to */
+};
+
+struct aim_user {
+	char username[64];
+	char alias[SELF_ALIAS_LEN]; 
+	char password[32];
+	char user_info[2048];
+	int options;
+	int protocol;
+	/* prpls can use this to save information about the user,
+	 * like which server to connect to, etc */
+	char proto_opt[7][256];
+
+	struct gaim_connection *gc;
+	irc_t *irc;
+};
 
 struct prpl {
+	int protocol;
 	int options;
-	/* You should set this to the name of your protocol.
-	 * - The user sees this name ie. when imcb_log() is used. */
-	const char *name;
-	void *data;
-	/* Maximum Message Size of this protocol.
-	 * - Introduced for OTR, in order to fragment large protocol messages.
-	 * - 0 means "unlimited". */
-	unsigned int mms;
-
-	/* Added this one to be able to add per-account settings, don't think
-	 * it should be used for anything else. You are supposed to use the
-	 * set_add() function to add new settings. */
-	void (* init)           (account_t *);
-	/* The typical usage of the login() function:
-	 * - Create an im_connection using imcb_new() from the account_t parameter.
-	 * - Initialize your myproto_data struct - you should store all your protocol-specific data there.
-	 * - Save your custom structure to im_connection->proto_data.
-	 * - Use proxy_connect() to connect to the server.
-	 */
-	void (* login)          (account_t *);
-	/* Implementing this function is optional. */
-	void (* keepalive)      (struct im_connection *);
-	/* In this function you should:
-	 * - Tell the server about you are logging out.
-	 * - g_free() your myproto_data struct as BitlBee does not know how to
-	 *   properly do so.
-	 */
-	void (* logout)         (struct im_connection *);
-
-	/* This function is called when the user wants to send a message to a handle.
-	 * - 'to' is a handle, not a nick
-	 * - 'flags' may be ignored
-	 */
-	int (* buddy_msg)      (struct im_connection *, char *to, char *message, int flags);
-	/* This function is called then the user uses the /away IRC command.
-	 * - 'state' contains the away reason.
-	 * - 'message' may be ignored if your protocol does not support it.
-	 */
-	void (* set_away)       (struct im_connection *, char *state, char *message);
-	/* Implementing this function is optional. */
-	int (* send_typing)    (struct im_connection *, char *who, int flags);
-
-	/* 'name' is a handle to add/remove. For now BitlBee doesn't really
-	 * handle groups, just set it to NULL, so you can ignore that
-	 * parameter. */
-	void (* add_buddy)      (struct im_connection *, char *name, char *group);
-	void (* remove_buddy)   (struct im_connection *, char *name, char *group);
-
-	/* Block list stuff. Implementing these are optional. */
-	void (* add_permit)     (struct im_connection *, char *who);
-	void (* add_deny)       (struct im_connection *, char *who);
-	void (* rem_permit)     (struct im_connection *, char *who);
-	void (* rem_deny)       (struct im_connection *, char *who);
-
-	/* Request profile info. Free-formatted stuff, the IM module gives back
-	   this info via imcb_log(). Implementing these are optional. */
-	void (* get_info)       (struct im_connection *, char *who);
-
-	/* Group chat stuff. */
-	/* This is called when the user uses the /invite IRC command.
-	 * - 'who' may be ignored
-	 * - 'message' is a handle to invite
-	 */
-	void (* chat_invite)    (struct groupchat *, char *who, char *message);
-	/* This is called when the user uses the /kick IRC command.
-	 * - 'who' is a handle to kick
-	 * - 'message' is a kick message or NULL
-	 */
-	void (* chat_kick)      (struct groupchat *, char *who, const char *message);
-	/* This is called when the user uses the /part IRC command in a group
-	 * chat. You just should tell the user about it, nothing more. */
-	void (* chat_leave)     (struct groupchat *);
-	/* This is called when the user sends a message to the groupchat.
-	 * 'flags' may be ignored. */
-	void (* chat_msg)       (struct groupchat *, char *message, int flags);
-	/* This is called when the user uses the /join #nick IRC command.
-	 * - 'who' is the handle of the nick
-	 */
-	struct groupchat *
-	(* chat_with)      (struct im_connection *, char *who);
-	/* This is used when the user uses the /join #channel IRC command.  If
-	 * your protocol does not support publicly named group chats, then do
-	 * not implement this. */
-	struct groupchat *
-	(* chat_join)      (struct im_connection *, const char *room,
-	                    const char *nick, const char *password, set_t **sets);
-	/* Change the topic, if supported. Note that BitlBee expects the IM
-	   server to confirm the topic change with a regular topic change
-	   event. If it doesn't do that, you have to fake it to make it
-	   visible to the user. */
-	void (* chat_topic)     (struct groupchat *, char *topic);
-
-	/* If your protocol module needs any special info for joining chatrooms
-	   other than a roomname + nickname, add them here. */
-	void (* chat_add_settings)      (account_t *acc, set_t **head);
-	void (* chat_free_settings)     (account_t *acc, set_t **head);
-
-	/* You can tell what away states your protocol supports, so that
-	 * BitlBee will try to map the IRC away reasons to them. If your
-	 * protocol doesn't have any, just return one generic "Away". */
-	GList *(* away_states)(struct im_connection *ic);
-
-	/* Mainly for AOL, since they think "Bung hole" == "Bu ngho le". *sigh*
-	 * - Most protocols will just want to set this to g_strcasecmp().*/
-	int (* handle_cmp) (const char *who1, const char *who2);
-
-	/* Implement these callbacks if you want to use imcb_ask_auth() */
-	void (* auth_allow)     (struct im_connection *, const char *who);
-	void (* auth_deny)      (struct im_connection *, const char *who);
-
-	/* Incoming transfer request */
-	void (* transfer_request) (struct im_connection *, file_transfer_t *ft, char *handle);
-
-	void (* buddy_data_add) (struct bee_user *bu);
-	void (* buddy_data_free) (struct bee_user *bu);
-
-	GList *(* buddy_action_list) (struct bee_user *bu);
-	void *(* buddy_action) (struct bee_user *bu, const char *action, char * const args[], void *data);
-
-	/* If null, equivalent to handle_cmp( ic->acc->user, who ) */
-	gboolean (* handle_is_self) (struct im_connection *, const char *who);
-
-	/* This sets/updates the im_connection->chatlist field with a
-	 * bee_chat_info_t GSList. This function should ensure the
-	 * bee_chat_list_finish() function gets called at some point
-	 * after the chat list is completely updated.
-	 */
-	void (* chat_list) (struct im_connection *, const char *server);
-
-	/* Some placeholders so eventually older plugins may cooperate with newer BitlBees. */
-	void *resv1;
-	void *resv2;
-	void *resv3;
-	void *resv4;
-	void *resv5;
-};
-
-struct plugin_info
-{
-	guint abiver;
-	const char *name;
-	const char *version;
-	const char *description;
-	const char *author;
-	const char *url;
-};
-
-#ifdef WITH_PLUGINS
-G_MODULE_EXPORT GList *get_plugins();
-#endif
-
-/* im_api core stuff. */
+	char *(* name)();
+
+	/* for ICQ and Yahoo, who have off/on per-conversation options */
+	/* char *checkbox; this should be per-connection */
+
+	GList *(* away_states)(struct gaim_connection *gc);
+	GList *(* actions)();
+	void   (* do_action)(struct gaim_connection *, char *);
+	/* user_opts returns a GList* of g_malloc'd struct proto_user_opts */
+	GList *(* user_opts)();
+	GList *(* chat_info)(struct gaim_connection *);
+
+	/* all the server-related functions */
+
+	/* a lot of these (like get_dir) are protocol-dependent and should be removed. ones like
+	 * set_dir (which is also protocol-dependent) can stay though because there's a dialog
+	 * (i.e. the prpl says you can set your dir info, the ui shows a dialog and needs to call
+	 * set_dir in order to set it) */
+
+	void (* login)		(struct aim_user *);
+	void (* close)		(struct gaim_connection *);
+	int  (* send_im)	(struct gaim_connection *, char *who, char *message, int len, int away);
+	int  (* send_typing)	(struct gaim_connection *, char *who, int typing);
+	void (* set_info)	(struct gaim_connection *, char *info);
+	void (* get_info)	(struct gaim_connection *, char *who);
+	void (* set_away)	(struct gaim_connection *, char *state, char *message);
+	void (* get_away)       (struct gaim_connection *, char *who);
+	void (* set_idle)	(struct gaim_connection *, int idletime);
+	void (* add_buddy)	(struct gaim_connection *, char *name);
+	void (* remove_buddy)	(struct gaim_connection *, char *name, char *group);
+	void (* add_permit)	(struct gaim_connection *, char *name);
+	void (* add_deny)	(struct gaim_connection *, char *name);
+	void (* rem_permit)	(struct gaim_connection *, char *name);
+	void (* rem_deny)	(struct gaim_connection *, char *name);
+	void (* set_permit_deny)(struct gaim_connection *);
+	void (* join_chat)	(struct gaim_connection *, GList *data);
+	void (* chat_invite)	(struct gaim_connection *, int id, char *who, char *message);
+	void (* chat_leave)	(struct gaim_connection *, int id);
+	void (* chat_whisper)	(struct gaim_connection *, int id, char *who, char *message);
+	int  (* chat_send)	(struct gaim_connection *, int id, char *message);
+	int  (* chat_open)	(struct gaim_connection *, char *who);
+	void (* keepalive)	(struct gaim_connection *);
+
+	/* get "chat buddy" info and away message */
+	void (* get_cb_info)	(struct gaim_connection *, int, char *who);
+	void (* get_cb_away)	(struct gaim_connection *, int, char *who);
+
+	/* save/store buddy's alias on server list/roster */
+	void (* alias_buddy)	(struct gaim_connection *, char *who);
+
+	/* change a buddy's group on a server list/roster */
+	void (* group_buddy)	(struct gaim_connection *, char *who, char *old_group, char *new_group);
+
+	void (* buddy_free)	(struct buddy *);
+
+	char *(* get_status_string) (struct gaim_connection *gc, int stat);
+};
+
+#define PROTO_TOC	0
+#define PROTO_OSCAR	1
+#define PROTO_YAHOO	2
+#define PROTO_ICQ	3
+#define PROTO_MSN	4
+#define PROTO_IRC	5
+#define PROTO_FTP	6
+#define PROTO_VGATE	7
+#define PROTO_JABBER	8
+#define PROTO_NAPSTER	9
+#define PROTO_ZEPHYR	10
+#define PROTO_GADUGADU	11
+#define PROTO_MAX	16
+
+extern char proto_name[PROTO_MAX][8];
+
+#define UC_UNAVAILABLE  1
+
+/* JABBER */
+#define UC_AWAY (0x02 | UC_UNAVAILABLE)
+#define UC_CHAT  0x04
+#define UC_XA   (0x08 | UC_UNAVAILABLE)
+#define UC_DND  (0x10 | UC_UNAVAILABLE)
+
+G_MODULE_EXPORT GSList *get_connections();
+extern struct prpl *proto_prpl[16];
+
+/* nogaim.c */
+int serv_send_im(irc_t *irc, user_t *u, char *msg, int flags);
+int serv_send_chat(irc_t *irc, struct gaim_connection *gc, int id, char *msg );
+
+G_MODULE_EXPORT signed int do_iconv( char *from_cs, char *to_cs, char *src, char *dst, size_t size, size_t maxbuf );
+char *set_eval_charset( irc_t *irc, set_t *set, char *value );
+
 void nogaim_init();
-G_MODULE_EXPORT GList *get_protocols();
-G_MODULE_EXPORT GList *get_protocols_disabled();
-G_MODULE_EXPORT GSList *get_connections();
-G_MODULE_EXPORT struct prpl *find_protocol(const char *name);
-G_MODULE_EXPORT gboolean is_protocol_disabled(const char *name);
-G_MODULE_EXPORT char *explain_unknown_protocol(const char *name);
-/* When registering a new protocol, you should allocate space for a new prpl
- * struct, initialize it (set the function pointers to point to your
- * functions), finally call this function. */
-G_MODULE_EXPORT void register_protocol(struct prpl *);
-
-/* Connection management. */
-/* You will need this function in prpl->login() to get an im_connection from
- * the account_t parameter. */
-G_MODULE_EXPORT struct im_connection *imcb_new(account_t *acc);
-G_MODULE_EXPORT void imc_free(struct im_connection *ic);
-/* Once you're connected, you should call this function, so that the user will
- * see the success. */
-G_MODULE_EXPORT void imcb_connected(struct im_connection *ic);
-/* This can be used to disconnect when something went wrong (ie. read error
- * from the server). You probably want to set the second parameter to TRUE. */
-G_MODULE_EXPORT void imc_logout(struct im_connection *ic, int allow_reconnect);
-
-/* Communicating with the user. */
-/* A printf()-like function to tell the user anything you want. */
-G_MODULE_EXPORT void imcb_log(struct im_connection *ic, char *format, ...) G_GNUC_PRINTF(2, 3);
-/* To tell the user an error, ie. before logging out when an error occurs. */
-G_MODULE_EXPORT void imcb_error(struct im_connection *ic, char *format, ...) G_GNUC_PRINTF(2, 3);
-
-/* To ask a your about something.
- * - 'msg' is the question.
- * - 'data' can be your custom struct - it will be passed to the callbacks.
- * - 'doit' or 'dont' will be called depending of the answer of the user.
- */
-G_MODULE_EXPORT void imcb_ask(struct im_connection *ic, char *msg, void *data, query_callback doit,
-                              query_callback dont);
-G_MODULE_EXPORT void imcb_ask_with_free(struct im_connection *ic, char *msg, void *data, query_callback doit,
-                                        query_callback dont, query_callback myfree);
-
-/* Two common questions you may want to ask:
- * - X added you to his contact list, allow?
- * - X is not in your contact list, want to add?
- */
-G_MODULE_EXPORT void imcb_ask_auth(struct im_connection *ic, const char *handle, const char *realname);
-G_MODULE_EXPORT void imcb_ask_add(struct im_connection *ic, const char *handle, const char *realname);
-
-/* Buddy management */
-/* This function should be called for each handle which are visible to the
- * user, usually after a login, or if the user added a buddy and the IM
- * server confirms that the add was successful. Don't forget to do this! */
-G_MODULE_EXPORT void imcb_add_buddy(struct im_connection *ic, const char *handle, const char *group);
-G_MODULE_EXPORT void imcb_remove_buddy(struct im_connection *ic, const char *handle, char *group);
-G_MODULE_EXPORT void imcb_rename_buddy(struct im_connection *ic, const char *handle, const char *realname);
-G_MODULE_EXPORT void imcb_buddy_nick_hint(struct im_connection *ic, const char *handle, const char *nick);
-G_MODULE_EXPORT void imcb_buddy_nick_change(struct im_connection *ic, const char *handle, const char *nick);
-G_MODULE_EXPORT void imcb_buddy_action_response(bee_user_t *bu, const char *action, char * const args[], void *data);
-
-G_MODULE_EXPORT void imcb_buddy_typing(struct im_connection *ic, const char *handle, guint32 flags);
-G_MODULE_EXPORT struct bee_user *imcb_buddy_by_handle(struct im_connection *ic, const char *handle);
-
-G_GNUC_DEPRECATED G_MODULE_EXPORT void imcb_clean_handle(struct im_connection *ic, char *handle);
-
-/* Actions, or whatever. */
-int imc_away_send_update(struct im_connection *ic);
-int imc_chat_msg(struct groupchat *c, char *msg, int flags);
-
-void imc_add_allow(struct im_connection *ic, char *handle);
-void imc_rem_allow(struct im_connection *ic, char *handle);
-void imc_add_block(struct im_connection *ic, char *handle);
-void imc_rem_block(struct im_connection *ic, char *handle);
-
-/* Misc. stuff */
-char *set_eval_timezone(set_t *set, char *value);
-gboolean auto_reconnect(gpointer data, gint fd, b_input_condition cond);
-void cancel_auto_reconnect(struct account *a);
-
-#endif
+int proto_away( struct gaim_connection *gc, char *away );
+char *set_eval_away_devoice( irc_t *irc, set_t *set, char *value );
+int handle_cmp( char *a, char *b, int protocol );
+
+gboolean auto_reconnect( gpointer data );
+void cancel_auto_reconnect( struct account *a );
+
+/* multi.c */
+G_MODULE_EXPORT struct gaim_connection *new_gaim_conn( struct aim_user *user );
+G_MODULE_EXPORT void destroy_gaim_conn( struct gaim_connection *gc );
+G_MODULE_EXPORT void set_login_progress( struct gaim_connection *gc, int step, char *msg );
+G_MODULE_EXPORT void hide_login_progress( struct gaim_connection *gc, char *msg );
+G_MODULE_EXPORT void hide_login_progress_error( struct gaim_connection *gc, char *msg );
+G_MODULE_EXPORT void serv_got_crap( struct gaim_connection *gc, char *format, ... );
+G_MODULE_EXPORT void account_online( struct gaim_connection *gc );
+G_MODULE_EXPORT void account_offline( struct gaim_connection *gc );
+G_MODULE_EXPORT void signoff( struct gaim_connection *gc );
+
+/* dialogs.c */
+G_MODULE_EXPORT void do_error_dialog( struct gaim_connection *gc, char *msg, char *title );
+G_MODULE_EXPORT void do_ask_dialog( struct gaim_connection *gc, char *msg, void *data, void *doit, void *dont );
+
+/* list.c */
+G_MODULE_EXPORT int bud_list_cache_exists( struct gaim_connection *gc );
+G_MODULE_EXPORT void do_import( struct gaim_connection *gc, void *null );
+G_MODULE_EXPORT void add_buddy( struct gaim_connection *gc, char *group, char *handle, char *realname );
+G_MODULE_EXPORT struct buddy *find_buddy( struct gaim_connection *gc, char *handle );
+G_MODULE_EXPORT void do_export( struct gaim_connection *gc );
+G_MODULE_EXPORT void signoff_blocked( struct gaim_connection *gc );
+
+G_MODULE_EXPORT void serv_buddy_rename( struct gaim_connection *gc, char *handle, char *realname );
+
+/* buddy_chat.c */
+G_MODULE_EXPORT void add_chat_buddy( struct conversation *b, char *handle );
+G_MODULE_EXPORT void remove_chat_buddy( struct conversation *b, char *handle, char *reason );
+
+/* prpl.c */
+G_MODULE_EXPORT void show_got_added( struct gaim_connection *gc, char *id, char *handle, const char *realname, const char *msg );
+
+/* server.c */                    
+G_MODULE_EXPORT void serv_got_update( struct gaim_connection *gc, char *handle, int loggedin, int evil, time_t signon, time_t idle, int type, guint caps );
+G_MODULE_EXPORT void serv_got_im( struct gaim_connection *gc, char *handle, char *msg, guint32 flags, time_t mtime, gint len );
+G_MODULE_EXPORT void serv_got_typing( struct gaim_connection *gc, char *handle, int timeout );
+G_MODULE_EXPORT void serv_got_chat_invite( struct gaim_connection *gc, char *handle, char *who, char *msg, GList *data );
+G_MODULE_EXPORT struct conversation *serv_got_joined_chat( struct gaim_connection *gc, int id, char *handle );
+G_MODULE_EXPORT void serv_got_chat_in( struct gaim_connection *gc, int id, char *who, int whisper, char *msg, time_t mtime );
+G_MODULE_EXPORT void serv_got_chat_left( struct gaim_connection *gc, int id );
+/* void serv_finish_login( struct gaim_connection *gc ); */
+
+/* util.c */
+G_MODULE_EXPORT char *utf8_to_str( const char *in );
+G_MODULE_EXPORT char *str_to_utf8( const char *in );
+G_MODULE_EXPORT void strip_linefeed( gchar *text );
+G_MODULE_EXPORT char *add_cr( char *text );
+G_MODULE_EXPORT char *tobase64( const char *text );
+G_MODULE_EXPORT char *normalize( const char *s );
+G_MODULE_EXPORT time_t get_time( int year, int month, int day, int hour, int min, int sec );
+G_MODULE_EXPORT void strip_html( char *msg );
+G_MODULE_EXPORT char * escape_html(const char *html);
+G_MODULE_EXPORT void info_string_append(GString *str, char *newline, char *name, char *value);
+
+#ifdef WITH_MSN
+/* msn.c */
+G_MODULE_EXPORT void msn_init( struct prpl *ret );
+#endif
+
+#ifdef WITH_OSCAR
+/* oscar.c */
+G_MODULE_EXPORT void oscar_init( struct prpl *ret );
+#endif
+
+#ifdef WITH_JABBER
+/* jabber.c */
+G_MODULE_EXPORT void jabber_init( struct prpl *ret );
+#endif
+
+#ifdef WITH_YAHOO
+/* yahoo.c */
+G_MODULE_EXPORT void byahoo_init( struct prpl *ret );
+#endif
+
+/* prefs.c */
+G_MODULE_EXPORT void build_block_list();
+G_MODULE_EXPORT void build_allow_list();
+
+struct conversation *conv_findchannel( char *channel );
+
+
+#endif
Index: protocols/oscar/AUTHORS
===================================================================
--- protocols/oscar/AUTHORS	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ protocols/oscar/AUTHORS	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,31 @@
+
+Anyone else want to be in here?
+
+---
+
+N: Adam Fritzler
+H: mid
+E: mid@auk.cx
+W: http://www.auk.cx/~mid,http://www.auk.cx/faim
+D: Wrote most of the wap of crap that you see before you.
+
+N: Josh Myer
+E: josh@joshisanerd.com
+D: OFT/ODC (not quite finished yet..), random little things, Munger-At-Large, compile-time warnings.
+
+N: Daniel Reed
+H: n, linuxkitty
+E: n@ml.org
+W: http://users.n.ml.org/n/
+D: Fixed aim_snac.c
+
+N: Eric Warmenhoven
+E: warmenhoven@linux.com
+D: Some OFT info, author of the faim interface for gaim
+
+N: Brock Wilcox
+H: awwaiid
+E: awwaiid@auk.cx
+D: Figured out original password roasting
+
+
